searchNodes=[{"doc":"Generate code from an Open API description This task requires two arguments: The configuration profile to use, and The location of the OpenAPI description. The description location can be given as an absolute path or a path relative to the Mix project where this task is run. Example mix api.gen default ../rest-api-description/spec.yaml","ref":"Mix.Tasks.Api.Gen.html","title":"Mix.Tasks.Api.Gen","type":"task"},{"doc":"Code generator for OpenAPI REST API descriptions Note It is not expected that clients will call functions in this module directly. Instead, consider using the mix api.gen task. This module provides a single function, run/2 , that accepts the name of a configuration profile and a list of files containing JSON or Yaml OpenAPI descriptions. It runs the three phases of code generation: OpenAPI.Reader OpenAPI.Processor OpenAPI.Renderer At the end, an OpenAPI.State struct is returned with all of the data that was used to generate the client code. For more information, see the readme or the available guides on configuration , plugins , or creating a client library .","ref":"OpenAPI.html","title":"OpenAPI","type":"module"},{"doc":"Using the given configuration profile , read the OpenAPI description contained in files and generate client code","ref":"OpenAPI.html#run/2","title":"OpenAPI.run/2","type":"function"},{"doc":"Information about the original invocation of the code generator Note It is not expected that clients will interact with this module directly.","ref":"OpenAPI.Call.html","title":"OpenAPI.Call","type":"module"},{"doc":"","ref":"OpenAPI.Call.html#t:t/0","title":"OpenAPI.Call.t/0","type":"type"},{"doc":"State for the overall code generation This struct contains data that is passed between phases of the generation. It includes the following fields: call : Information about the original call to the generator, including the configuration profile and the spec files passed. files : After the render phase, contains a list of OpenAPI.Renderer.File.t/0 structs that were written. operations : After the process phase, contains a list of OpenAPI.Processor.Operation.t/0 structs that were processed. schemas : After the process phase, contains a map of schema references to their OpenAPI.Processor.Schema.t/0 structs. The reference-keyed map is included to make it easier for render callbacks to look up a schema by its reference, as this is often how operations will refer to them. spec : After the read phase, contains the parsed and merged OpenAPI description(s). All of this state is managed by the code generator between phases, and it is unlikely that a callback would need to read or write to this struct directly.","ref":"OpenAPI.State.html","title":"OpenAPI.State","type":"module"},{"doc":"OpenAPI generator state","ref":"OpenAPI.State.html#t:t/0","title":"OpenAPI.State.t/0","type":"type"},{"doc":"Raw Yaml input.","ref":"OpenAPI.State.html#t:yaml/0","title":"OpenAPI.State.yaml/0","type":"type"},{"doc":"Phase one of code generation The read phase begins with one or more filenames (JSON or YAML) to read. Each document should be the root of an OpenAPI description (usually beginning with an openapi key and version number). As the first step, they are parsed into large, nested maps and stored in the state based on their filename. Then, each document is parsed into structs based on the OpenAPI document definition. Note that this library is not meant to &quot;validate&quot; OpenAPI descriptions. Errors may be thrown only when there are details missing that affect the operation of the code generator. Because of this, you may be able to &quot;get away with&quot; generating code from an incomplete or invalid document. Note Functions in this module are used by the main OpenAPI module. It is unlikely that you will call these functions directly, unless you are reimplementing one of the core functions. If this happens, please share your use-case with the maintainers; a plugin might be warranted. Configuration All configuration for this phase lives under the reader key in each profile: config :oapi_generator , default : [ reader : [ ... ] ] The following options are available: additional_files : List of paths to supplemental root files of an API description. See Supplemental Descriptions below for more information. Defaults to no additional files. file : Path to the (likely vendor-supplied) root file of an API description. This information is often supplied to the mix api.gen task, since individual client library maintainers may keep the API description document in different locations. However, if the API description is included in the client library repository, then this configuration can be used instead. If unset, the filename must be supplied to mix api.gen . Supplemental Descriptions Sometimes, the OpenAPI description provided by a vendor is incomplete. Client library authors may choose to write supplemental descriptions that &quot;fill in the gaps&quot;. Although these files must contain the root of an OpenAPI description (including an openapi key and version number) they may reference parts of the vendor-provided specification. For example, GitHub provides special ID-based API routes like /repositories/{id} that are not documented in its OpenAPI description. A client library author may create a supplemental description that looks like this (abbreviated): openapi: 3.1.0 paths: &quot;/repositories/{id}&quot;: get: summary: Get a repository by ID operationId: repos/get-by-id parameters: - &quot;$ref&quot;: &quot;#/components/parameters/id&quot; responses: '200': description: Response content: application/json: schema: &quot;$ref&quot;: &quot;#/components/schemas/full-repository&quot; Note that references to schemas contained in the vendor-supplied description must be modified to use accurate paths. Assuming the supplemental file is committed in the client library repository, authors may use the additional_files configuration to ensure it is always processed along with the vendor-supplied description: config :oapi_generator , default : [ reader : [ additional_files : [ &quot;path/to/supplement.yaml&quot; ] ] ] During the reading phase, the two root documents will be combined as if each root key were concatenated (for example, the paths from one file were copied to the other). Keys like info will always use the vendor-supplied data. After the reading phase, the documents will be treated as one API description, although plugins will have the opportunity to see the source of the data when necessary.","ref":"OpenAPI.Reader.html","title":"OpenAPI.Reader","type":"module"},{"doc":"","ref":"OpenAPI.Reader.html#ensure_file/2","title":"OpenAPI.Reader.ensure_file/2","type":"function"},{"doc":"Run the reading phase of the code generator","ref":"OpenAPI.Reader.html#run/1","title":"OpenAPI.Reader.run/1","type":"function"},{"doc":"Configuration for the read phase For more information, see the Configuration section of the documentation for OpenAPI.Reader .","ref":"OpenAPI.Reader.Config.html","title":"OpenAPI.Reader.Config","type":"module"},{"doc":"","ref":"OpenAPI.Reader.Config.html#t:t/0","title":"OpenAPI.Reader.Config.t/0","type":"type"},{"doc":"State of the reader phase of code generation This struct is created at the beginning of the read phase using data from the overall OpenAPI.State . It is fully managed by the read phase, and it is unlikely that client libraries would read or write to this struct.","ref":"OpenAPI.Reader.State.html","title":"OpenAPI.Reader.State","type":"module"},{"doc":"Decode function for raw Yaml","ref":"OpenAPI.Reader.State.html#t:decoder/0","title":"OpenAPI.Reader.State.decoder/0","type":"type"},{"doc":"Decode function for raw Yaml","ref":"OpenAPI.Reader.State.html#t:decoder/1","title":"OpenAPI.Reader.State.decoder/1","type":"type"},{"doc":"Key or index of a Yaml document.","ref":"OpenAPI.Reader.State.html#t:path_segment/0","title":"OpenAPI.Reader.State.path_segment/0","type":"type"},{"doc":"OpenAPI reader state","ref":"OpenAPI.Reader.State.html#t:t/0","title":"OpenAPI.Reader.State.t/0","type":"type"},{"doc":"Raw Yaml input","ref":"OpenAPI.Reader.State.html#t:yaml/0","title":"OpenAPI.Reader.State.yaml/0","type":"type"},{"doc":"Phase two of code generation The process phase begins with a decoded API description from the read phase. It may represent the contents of one or more files, including one or more root descriptions if supplemental files were used. This library takes an &quot;operation first&quot; mindset when processing the description. Schemas are ignored until they are referenced by an operation (ex. as a response body). It is the job of this phase to observe all of the operations and their referenced schemas, process them into data structures more relevant to code generation, and prepare the data for rendering. Customization At several points during code generation, it may be useful to customize the behaviour of the processor. For this purpose, this module is a Behaviour with most of its critical logic implemented as optional callbacks.","ref":"OpenAPI.Processor.html","title":"OpenAPI.Processor","type":"behaviour"},{"doc":"Whether to render the given operation in the generated code If this function returns true , the operation will not appear in the generated code. See OpenAPI.Processor.Ignore.ignore_operation?/2 for the default implementation.","ref":"OpenAPI.Processor.html#c:ignore_operation?/2","title":"OpenAPI.Processor.ignore_operation?/2","type":"callback"},{"doc":"Whether to render the given schema in the generated code If this function returns true , the schema will not appear in the generated code (unless it returns false when presented in another context) and a plain map will be used as its type. See OpenAPI.Processor.Ignore.ignore_schema?/2 for the default implementation.","ref":"OpenAPI.Processor.html#c:ignore_schema?/2","title":"OpenAPI.Processor.ignore_schema?/2","type":"callback"},{"doc":"Construct a docstring for the given operation This function accepts the operation spec as well as a list of the processed query params associated with the operation. See OpenAPI.Processor.Operation.docstring/3 for the default implementation.","ref":"OpenAPI.Processor.html#c:operation_docstring/3","title":"OpenAPI.Processor.operation_docstring/3","type":"callback"},{"doc":"Choose the name of the client function for the given operation This function accepts the operation spec and chooses a name for the client function that will be generated. The name must be unique within its module (see operation_module_names/2 ). See OpenAPI.Processor.Naming.operation_function/2 for the default implementation.","ref":"OpenAPI.Processor.html#c:operation_function_name/2","title":"OpenAPI.Processor.operation_function_name/2","type":"callback"},{"doc":"Choose the names of the client function modules for the given operation Each operation may have multiple client functions in different modules. This function accepts the operation spec and returns a list of all of its operation modules. See OpenAPI.Processor.Naming.operation_modules/2 for the default implementation.","ref":"OpenAPI.Processor.html#c:operation_module_names/2","title":"OpenAPI.Processor.operation_module_names/2","type":"callback"},{"doc":"Collect a list of request content types and their associated schemas This function accepts the operation spec and returns a list of tuples containing the content type (ex. &quot;application/json&quot;) and the schema associated with that type. See OpenAPI.Processor.Operation.request_body/2 for the default implementation.","ref":"OpenAPI.Processor.html#c:operation_request_body/2","title":"OpenAPI.Processor.operation_request_body/2","type":"callback"},{"doc":"Choose and cast the request method for the given operation This function accepts the operation spec and must return the (lowercase) atom representing the HTTP method. See OpenAPI.Processor.Operation.request_method/2 for the default implementation.","ref":"OpenAPI.Processor.html#c:operation_request_method/2","title":"OpenAPI.Processor.operation_request_method/2","type":"callback"},{"doc":"Collect a list of response status codes and their associated schemas This function accepts the operation spec and returns a list of tuples containing the status codes (ex. 200 or :default ) and a list of tuples with the possible content types and the schema associated with that code and type. See OpenAPI.Processor.Operation.response_body/2 for the default implementation.","ref":"OpenAPI.Processor.html#c:operation_response_body/2","title":"OpenAPI.Processor.operation_response_body/2","type":"callback"},{"doc":"Run the processing phase of the code generator This functions is used by the main OpenAPI module. It is unlikely that you will call this function directly, unless you are reimplementing one of the core functions. If this happens, please share your use-case with the maintainers; a plugin might be warranted.","ref":"OpenAPI.Processor.html#run/1","title":"OpenAPI.Processor.run/1","type":"function"},{"doc":"Choose the name of the module and type for the given schema Each module may contain multiple schemas with distinct types. By convention, the default type (used for single-schema modules) is :t , as in MySchema.t() . Additional schemas in the same module may represent variations on the default type, such as a User.public() schema containing a reduced set of fields from User.t() . See OpenAPI.Processor.Naming.schema_module_and_type/2 for the default implementation.","ref":"OpenAPI.Processor.html#c:schema_module_and_type/2","title":"OpenAPI.Processor.schema_module_and_type/2","type":"callback"},{"doc":"Ignore operations and schemas from the description This module contains the default implementations for: OpenAPI.Processor.ignore_operation?/2 OpenAPI.Processor.ignore_schema?/2 Configuration All configuration for the functions in this module is contained in a key ignore of the active configuration profile. For example: # config/config.exs config :oapi_generator , default : [ ignore : [ &quot;IgnoredOperation&quot; , ~r&quot;/components/schemas/ignored-&quot; ] ] Each element of the ignored list is a pattern. Patterns are compared against the operation IDs and paths of an operation, and the paths and titles of a schema. If a string is given, it is compared for equality. Regular expressions are tested using Regex.match?/2 . If any pattern matches the tested operation or schema, it will be excluded.","ref":"OpenAPI.Processor.Ignore.html","title":"OpenAPI.Processor.Ignore","type":"module"},{"doc":"Ignore operations based on configured patterns of IDs and paths Default implementation of OpenAPI.Processor.ignore_operation?/2 . In this implementation, patterns from the ignore configuration key are compared against each operation ID and path. If a string pattern matches exactly, or regular expression pattern matches according to Regex.match?/2 , the operation will be ignored.","ref":"OpenAPI.Processor.Ignore.html#ignore_operation?/2","title":"OpenAPI.Processor.Ignore.ignore_operation?/2","type":"function"},{"doc":"Ignore schemas based on configured patterns of paths and titles Default implementation of OpenAPI.Processor.ignore_schema?/2 . In this implementation, patterns from the ignore configuration key are compared against each schema title and path. If a string pattern matches exactly, or regular expression pattern matches according to Regex.match?/2 , the schema will be ignored. This often means the type will be replaced by a plain map .","ref":"OpenAPI.Processor.Ignore.html#ignore_schema?/2","title":"OpenAPI.Processor.Ignore.ignore_schema?/2","type":"function"},{"doc":"Definition of a module to ignore","ref":"OpenAPI.Processor.Ignore.html#t:definition/0","title":"OpenAPI.Processor.Ignore.definition/0","type":"type"},{"doc":"Default implementation for naming-related callbacks This module contains the default implementations for: OpenAPI.Processor.operation_function_name/2 OpenAPI.Processor.operation_module_names/2 OpenAPI.Processor.schema_module_and_type/2 It also includes several helper functions that are used by the default implementations. Library authors implementing their own naming-related callbacks may find these helpful. Configuration All configuration offered by the functions in this module lives under the naming key of the active configuration profile. For example (default values shown): # config/config.exs config :oapi_generator , default : [ naming : [ default_operation_module : Operations , group : [ ] , merge : [ ] , rename : [ ] ] ]","ref":"OpenAPI.Processor.Naming.html","title":"OpenAPI.Processor.Naming","type":"module"},{"doc":"Group schema modules into configured namespaces This function accepts a tuple with the module and type of a schema as strings, along with the processor state, and returns a modified tuple according to the configured groups. Discussion Schemas in an OpenAPI description can have extensively long names. For example, GitHub has a schema called actions-cache-usage-by-repository . Along with all other actions-related schemas, we can cut down the top-level module namespace by grouping on Actions or even further: group : [ Actions , Actions.CacheUsage ] Even simple renaming and groups can take a raw OpenAPI description and turn it into a library that feels friendly to users. Configuration Module namespaces can be configured as a list of modules in the naming.group key of a configuration profile: config :oapi_generator , default : [ naming : [ group : [ Author , Author.Bio Comment , # ... ] ] ] Examples The configuration above includes three module namespaces for grouping: Author , Author.Bio , and Comment . These rules would create the following transformations (types omitted because they do not change): AuthorAvatar =&gt; Author.Avatar AuthorBio =&gt; Author.Bio AuthorBioUpdate =&gt; Author.Bio.Update PostComment =&gt; PostComment Note that the desired grouping must appear at the start of the module name: PostComment is unaffected by the Comment group configuration. As a result, it is also important that Author appear in the configuration before Author.Bio , otherwise Author.Bio would fail to match the beginning of AuthorBioUpdate resulting in Author.BioUpdate (since the Author configuration would still match afterwards).","ref":"OpenAPI.Processor.Naming.html#group_schema/2","title":"OpenAPI.Processor.Naming.group_schema/2","type":"function"},{"doc":"Merge schemas based on configured pairs of patterns and replacements This function accepts a tuple with the module and type of a schema as strings, along with the processor state, and returns a modified tuple according to the configured merges. Discussion OpenAPI descriptions may have multiple schemas that are closely related or even duplicated. Merging gives the power to consolidate these schemas into a single struct that is easy to use. For example, the GitHub API description used to have schemas repository , full-repository , and nullable-repository . While the &quot;full&quot; repository added additional properties, the &quot;nullable&quot; variant was just that: all of the same properties, but the schema was nullable. This kind of oddity in the OpenAPI specification is exactly what makes most generated code difficult to use. The following merge settings would help clean this up: merge : [ { &quot;FullRepository&quot; , &quot;Repository&quot; } , { ~r/^Nullable/ , &quot;&quot; } ] In the first line, we tell the generator to merge FullRepository into Repository (the original module names based on the names of the schemas). Because the destination module appears at the end of the original module, the word &quot;Repository&quot; will be dropped from the type: FullRepository =&gt; Repository :: Repository . full ( ) This renaming of the type is automatic for prefixes and suffixes. If no overlap is found, then the full (underscored) schema name will be used for the type: SimpleUser =&gt; User :: User . simple ( ) PullRequestSimple =&gt; PullRequest :: PullRequest . simple ( ) MySchema =&gt; Unrelated :: Unrelated . my_schema ( ) If the destination module is later renamed or grouped, the merged schemas will processed in the same way. Configuration Merges are configured as a list of tuples in the naming.merge key of a configuration profile: config :oapi_generator , default : [ naming : [ merge : [ { &quot;PrivateUser&quot; , &quot;User&quot; } , { ~r/Simple$/ , &quot;&quot; } ] ] ] If the first element of the tuple is a string, it will be compared for an exact match to the schema's module name. If the first element of the tuple is a regular express, it will be compared to the schema's module name using Regex.match?/2 . If it matches, the module name will be replaced with the second element of the tuple. After the module name replacement, the type name may be modified. If new the module name is the first or last part of the original module name, the leftover portion will be used as the type. For example, with the configuration above, the following transformations take place: PrivateUser . t ( ) =&gt; User . private ( ) UserSimple . t ( ) =&gt; User . simple ( ) In the case that the new module name is not a prefix or suffix of the original, the entire underscored original module name is used as the new type.","ref":"OpenAPI.Processor.Naming.html#merge_schema/2","title":"OpenAPI.Processor.Naming.merge_schema/2","type":"function"},{"doc":"Normalize an identifier into snake_case Example iex&gt; normalize_identifier ( &quot;get-/customer/purchases/{date}_byId&quot; ) &quot;get_customer_purchases_date_by_id&quot;","ref":"OpenAPI.Processor.Naming.html#normalize_identifier/1","title":"OpenAPI.Processor.Naming.normalize_identifier/1","type":"function"},{"doc":"Choose the name of an operation client function based on its operation ID Default implementation of OpenAPI.Processor.operation_function_name/2 . In this implementation, the operation ID is split up by slash characters with only the last portion taken (ex. &quot;repos/get&quot; becomes &quot;get&quot;), assuming that the module name will use the remaining portions. Then the value is normalized to be atom-friendly. Note that this function creates new atoms, and should not be run in a production environment.","ref":"OpenAPI.Processor.Naming.html#operation_function/2","title":"OpenAPI.Processor.Naming.operation_function/2","type":"function"},{"doc":"Choose the names of modules containing the given operation Default implementation of OpenAPI.Processor.operation_module_names/2 . This generator generates a set of modules with functions in them according to some normalization rules: Operation tags and IDs are normalized for spaces, slashes, etc. Operation tags are used to generate modules that group operation functions (unless naming.operation_use_tags is false ) Operation IDs with slashes will be split, with the initial segments (everything except the last segment) used as segments of a module Examples: Operation foo with tag bar =&gt; Bar.foo Operation foo/bar with tag baz =&gt; Baz.foo_bar Operation foo/bar without tags =&gt; Foo.bar Each operation may exist in multiple modules depending on the quantity of tags and the format of the operation ID. If the operation does not have slashes in its ID and does not have any tags, then the configured :default_operation_module or [output.base_module].Operations becomes the module by default. Configuration Use naming.default_operation_module to configure the catch-all module name. Note that the configured name should not include the base module, if it is set in output.base_module . The following configuration would result in a module named MyClientLibrary.Operations : config :oapi_generator , default : [ naming : [ default_operation_module : Operations , operation_use_tags : true ] , output : [ base_module : MyClientLibrary ] ] Set naming.operation_use_tags to false to disable the use of tags when creating modules.","ref":"OpenAPI.Processor.Naming.html#operation_modules/2","title":"OpenAPI.Processor.Naming.operation_modules/2","type":"function"},{"doc":"Choose a starting schema module and type name based on title and context Returns a tuple containing the {module, type} , such as {&quot;MySchema&quot;, &quot;t&quot;} . This function does not consider schema renaming or merging. It uses the title, context, and location of the schema within the specification to determine an initial set of names. Schemas located in components/schemas are named based on their key in the schemas map, so a schema located at components/schemas/my_schema will become MySchema.t() . If a schema has a context attached (such as a request body or response body for an operation) then it will be named based on the operation. Finally, if a schema has a defined title, this will be used as the name. If none of this information is available, {nil, &quot;map&quot;} is returned. Callers of this function will almost certainly want to perform further processing.","ref":"OpenAPI.Processor.Naming.html#raw_schema_module_and_type/1","title":"OpenAPI.Processor.Naming.raw_schema_module_and_type/1","type":"function"},{"doc":"Turn a content type (ex. &quot;application/json&quot; ) into a readable type (ex. &quot;json&quot; ) This is used by the default implementation of the schema module/type name function while constructing the type of a request or response body that is otherwise unnamed. If an unknown content type is passed, this function returns an empty string to avoid including the content type in the name (although this could cause collisions).","ref":"OpenAPI.Processor.Naming.html#readable_content_type/1","title":"OpenAPI.Processor.Naming.readable_content_type/1","type":"function"},{"doc":"Rename schema modules based on configured patterns This function accepts a tuple with the module and type of a schema as strings, along with the processor state, and returns a modified tuple according to the configured replacements. Configuration Module replacements can be configured as a list of tuples in the naming.rename key of a configuration profile: config :oapi_generator , default : [ naming : [ rename : [ { &quot;Api&quot; , &quot;API&quot; } , { ~r/^Bio/ , &quot;Author.Bio&quot; } , # ... ] ] ] The contents of each tuple will be fed into String.replace/3 , for example: &gt; String . replace ( &quot;MyApiResponse&quot; , &quot;Api&quot; , &quot;API&quot; ) Examples In the configuration above, there are two replacements configured: the string pattern &quot;Api&quot; will be replaced with &quot;API&quot; , and the regular expression pattern ^Bio will be replaced with &quot;Author.Bio&quot; . These rules would create the following transformations (types omitted because they do not change): MyApiResponse =&gt; MyAPIResponse Apiary =&gt; APIary BioUpdate =&gt; Author.BioUpdate EditorBio =&gt; EditorBio Note that replacements can have unintended side-effects. For example, while we correctly capitalized MyApiResponse using the &quot;Api&quot; pattern, we also replaced APIary . Regular expressions lend more powerful and precise replacement patterns. This includes the ability to use capture expressions (ex. ~r/(Api)([A-Z]|$)/ ) and replacements that reference those captures (ex. &quot;API\\\\2&quot; ). See String.replace/3 for more information.","ref":"OpenAPI.Processor.Naming.html#rename_schema/2","title":"OpenAPI.Processor.Naming.rename_schema/2","type":"function"},{"doc":"Choose the name of the schema's module and type Default implementation of OpenAPI.Processor.schema_module_and_type/2 . Most of the configuration of this project relates to the manipulation of schema names. It is important to understand the order of operations. As an example, imagine an OpenAPI description has the following schemas: #/components/schemas/simple-user #/components/schemas/user #/components/schemas/user-preferences And the following configuration: config :oapi_generator , default : [ naming : [ group : [ User ] , merge : [ { &quot;SimpleUser&quot; , &quot;User&quot; } ] rename : [ { ~r/Preferences/ , &quot;Settings&quot; } ] ] , output : [ base_module : Example ] ] In this case, naming would proceed as follows: Schemas in the OpenAPI descriptions are turned into Elixir modules based on their location, context, or title by raw_schema_module_and_type/1 : #/components/schemas/simple-user =&gt; SimpleUser.t() #/components/schemas/user =&gt; User.t() #/components/schemas/user-preferences =&gt; UserPreferences.t() Merge settings are applied based on the original names of the schemas by merge_schema/2 : SimpleUser . t ( ) =&gt; User . simple ( ) Rename settings are applied based on the merged module names by rename_schema/2 : UserPreferences . t ( ) =&gt; UserSettings . t ( ) Group settings are applied based on the renamed module names by group_schema/2 : UserSettings . t ( ) =&gt; User.Settings . t ( ) The base module is applied to get the final names: User . simple ( ) =&gt; Example.User . simple ( ) User . t ( ) =&gt; Example.User . t ( ) User.Settings . t ( ) =&gt; Example.User.Settings . t ( ) Collapsing Note that User.simple() and User.t() will end up in the same file as a result of the merge, sharing the same struct for their responses (with distinct typespecs).","ref":"OpenAPI.Processor.Naming.html#schema_module_and_type/2","title":"OpenAPI.Processor.Naming.schema_module_and_type/2","type":"function"},{"doc":"","ref":"OpenAPI.Processor.Naming.html#t:module_and_type/0","title":"OpenAPI.Processor.Naming.module_and_type/0","type":"type"},{"doc":"","ref":"OpenAPI.Processor.Naming.html#t:raw_module_and_type/0","title":"OpenAPI.Processor.Naming.raw_module_and_type/0","type":"type"},{"doc":"Default plugin for formatting operations This module also provides the Operation struct that is used by the renderer.","ref":"OpenAPI.Processor.Operation.html","title":"OpenAPI.Processor.Operation","type":"module"},{"doc":"Create the contents of an @doc string for the given operation Default implementation of OpenAPI.Processor.operation_docstring/3 . The docstring constructed by this function will contain a summary line provided by the operation summary (if available) or the request method and path otherwise. It will incorporate the operation description (if available) and link to any included external documentation. Finally, all query parameters (which are part of the opts argument) are documented. @doc &quot;&quot;&quot; Summary of the operation or method and path Description of the operation, which generally provides more information. ## Options * `param`: query parameter description ## Resources * [External Doc Description](link to external documentation) &quot;&quot;&quot;","ref":"OpenAPI.Processor.Operation.html#docstring/3","title":"OpenAPI.Processor.Operation.docstring/3","type":"function"},{"doc":"Collect request content types and their associated schemas Default implementation of OpenAPI.Processor.operation_request_body/2 .","ref":"OpenAPI.Processor.Operation.html#request_body/2","title":"OpenAPI.Processor.Operation.request_body/2","type":"function"},{"doc":"Cast the HTTP method to an atom Default implementation of OpenAPI.Processor.operation_request_method/2 .","ref":"OpenAPI.Processor.Operation.html#request_method/2","title":"OpenAPI.Processor.Operation.request_method/2","type":"function"},{"doc":"Collect response status codes and their associated schemas Default implementation of OpenAPI.Processor.operation_response_body/2 . In this implementation, all schemas are returned regardless of content type. It is possible for the same status code to have multiple schemas, in which case the renderer should compose a union type for the response.","ref":"OpenAPI.Processor.Operation.html#response_body/2","title":"OpenAPI.Processor.Operation.response_body/2","type":"function"},{"doc":"HTTP method","ref":"OpenAPI.Processor.Operation.html#t:method/0","title":"OpenAPI.Processor.Operation.method/0","type":"type"},{"doc":"Request content types and their associated schemas","ref":"OpenAPI.Processor.Operation.html#t:request_body/0","title":"OpenAPI.Processor.Operation.request_body/0","type":"type"},{"doc":"Request content types and their associated schema specs","ref":"OpenAPI.Processor.Operation.html#t:request_body_unprocessed/0","title":"OpenAPI.Processor.Operation.request_body_unprocessed/0","type":"type"},{"doc":"Response status codes and their associated schemas","ref":"OpenAPI.Processor.Operation.html#t:response_body/0","title":"OpenAPI.Processor.Operation.response_body/0","type":"type"},{"doc":"Response status codes and their associated schema specs","ref":"OpenAPI.Processor.Operation.html#t:response_body_unprocessed/0","title":"OpenAPI.Processor.Operation.response_body_unprocessed/0","type":"type"},{"doc":"Processed operation data used by the renderer","ref":"OpenAPI.Processor.Operation.html#t:t/0","title":"OpenAPI.Processor.Operation.t/0","type":"type"},{"doc":"Provides the Param struct that is used by the renderer","ref":"OpenAPI.Processor.Operation.Param.html","title":"OpenAPI.Processor.Operation.Param","type":"module"},{"doc":"Location of the param","ref":"OpenAPI.Processor.Operation.Param.html#t:location/0","title":"OpenAPI.Processor.Operation.Param.location/0","type":"type"},{"doc":"Processed param data used by the renderer","ref":"OpenAPI.Processor.Operation.Param.html#t:t/0","title":"OpenAPI.Processor.Operation.Param.t/0","type":"type"},{"doc":"Processed schema used by the renderer This struct is created by the Processor to hold only the data necessary for rendering schemas and their types. It has the following fields: context : List of contexts where the schema is found in the API description. fields : List of OpenAPI.Processor.Schema.Field.t/0 structs contained in the schema. module_name : Name of the module where the schema will be defined. type_name : Name of the schema's type within its module. All of this data is managed by the code generator, and it is unlikely that a callback would need to modify this struct directly.","ref":"OpenAPI.Processor.Schema.html","title":"OpenAPI.Processor.Schema","type":"module"},{"doc":"Processed schema used by the renderer","ref":"OpenAPI.Processor.Schema.html#t:t/0","title":"OpenAPI.Processor.Schema.t/0","type":"type"},{"doc":"Provides the Field struct that is used by the renderer This struct is created by the Processor to hold only the data necessary for rendering fields and their types. It has the following fields: name : Name of the field in its parent schema nullable : Whether the field is defined as nullable private : Whether the field was added via the output.extra_fields configuration required : Whether the field is marked as required by its parent schema type : Internal representation of the field's type","ref":"OpenAPI.Processor.Schema.Field.html","title":"OpenAPI.Processor.Schema.Field","type":"module"},{"doc":"Processed field data used by the renderer","ref":"OpenAPI.Processor.Schema.Field.html#t:t/0","title":"OpenAPI.Processor.Schema.Field.t/0","type":"type"},{"doc":"State of the process phase of code generation This struct is created at the beginning of the process phase using data from the overall generator OpenAPI.State . It has the following fields: implementation : Module configured as the implementation of the processor (defaults to OpenAPI.Processor ). Callbacks must use this field when calling other process callbacks. operations : Cumulative list of OpenAPI.Processor.Operation.t/0 structs identified and processed so far. profile : Name of the active configuration profile. Callbacks must use this field when looking up configuration from the application environment. schema_specs_by_ref : Cumulative map of raw schema specifications keyed by the internal ref s used to refer to them in types. schema_refs_by_path : Cumulative map of internal ref s used to refer to schemas keyed by the original paths where they could be found in the spec files. schemas_by_ref : Cumulative map of processed OpenAPI.Processor.Schema.t/0 structs keyed by the internal ref s used to refer to them in types, as they are processed. spec : The original parsed OpenAPI description. All of this data is managed by the code generator, and it is unlikely that a callback would need to transform this struct directly.","ref":"OpenAPI.Processor.State.html","title":"OpenAPI.Processor.State","type":"module"},{"doc":"Get a schema reference by the last ref file/path","ref":"OpenAPI.Processor.State.html#get_schema_ref_by_path/2","title":"OpenAPI.Processor.State.get_schema_ref_by_path/2","type":"function"},{"doc":"Add a schema spec to the processor state and generate a reference for it","ref":"OpenAPI.Processor.State.html#put_schema_spec/2","title":"OpenAPI.Processor.State.put_schema_spec/2","type":"function"},{"doc":"","ref":"OpenAPI.Processor.State.html#t:t/0","title":"OpenAPI.Processor.State.t/0","type":"type"},{"doc":"","ref":"OpenAPI.Processor.Type.html","title":"OpenAPI.Processor.Type","type":"module"},{"doc":"Create an internal type representation of the given schema This function supports referencing object schemas in the processor state. As a result, if it encounters an object schema as a sub-field of the given schema, it will potentially modify the processor state in order to stash a new reference.","ref":"OpenAPI.Processor.Type.html#from_schema/2","title":"OpenAPI.Processor.Type.from_schema/2","type":"function"},{"doc":"","ref":"OpenAPI.Processor.Type.html#is_primitive/1","title":"OpenAPI.Processor.Type.is_primitive/1","type":"macro"},{"doc":"Create an internal type representation of the given schema This function does not support objects or other schemas that would be stored in the processor state. If a schema may contain such a reference, use from_schema/2 instead. It is expected that this function is called in cases when the range of possible types are known to be limited, such as query or path parameters.","ref":"OpenAPI.Processor.Type.html#primitive_from_schema/1","title":"OpenAPI.Processor.Type.primitive_from_schema/1","type":"function"},{"doc":"Literal values, as found in const and enum definitions","ref":"OpenAPI.Processor.Type.html#t:literal/0","title":"OpenAPI.Processor.Type.literal/0","type":"type"},{"doc":"Basic type These types represent a subset of the six primitive values defined by JSON schema (omitting object and array, which are represented in t/0 .) Note that both integer and number are acceptable types, with the latter covering both integer and decimal numbers.","ref":"OpenAPI.Processor.Type.html#t:primitive/0","title":"OpenAPI.Processor.Type.primitive/0","type":"type"},{"doc":"Special cases of the string type binary represents binary data that may be encoded, while generic represents a generic string without a formatting constraint.","ref":"OpenAPI.Processor.Type.html#t:string_format/0","title":"OpenAPI.Processor.Type.string_format/0","type":"type"},{"doc":"Internal representation of types In addition to the primitive/0 types, values can be constants or enums defined by literal/0 values. They can also be arrays or objects, as well as the union of multiple type definitions. If a value is nullable, it will be expressed as the union with :null . Elixir references ( reference/0 ) represent schemas stored in the processor State .","ref":"OpenAPI.Processor.Type.html#t:t/0","title":"OpenAPI.Processor.Type.t/0","type":"type"},{"doc":"Unnatural types introduced by the generator These types may be introduced in extra fields or when referenced schemas are ignored.","ref":"OpenAPI.Processor.Type.html#t:unnatural/0","title":"OpenAPI.Processor.Type.unnatural/0","type":"type"},{"doc":"Phase three of code generation The render phase begins with operation and schema structs created during the process phase. It uses this data to construct and save files containing Elixir source code. Most of the work done by this phase involves the manipulation of Elixir ASTs.","ref":"OpenAPI.Renderer.html","title":"OpenAPI.Renderer","type":"behaviour"},{"doc":"Convert the Abstract Syntax Tree (AST) form of the file into formatted code This callback can expect a OpenAPI.Renderer.File.t/0 struct with the completed contents of the file included in the ast field. Nodes of the AST may include optional formatting metadata (ex. delimiter , indentation , or end_of_expression ). It is recommended that the formatter adhere to the standard configuration of the default Mix formatter (for example, formatting to a line width of 98) in order to avoid a large amount of changes should someone run mix format on the generated code. The return value of the callback can be iodata (strings do not need to be concatenated), and it will be stored in the contents field of the file. See OpenAPI.Renderer.Util.format/2 for the default implementation.","ref":"OpenAPI.Renderer.html#c:format/2","title":"OpenAPI.Renderer.format/2","type":"callback"},{"doc":"Choose the filesystem location for a rendered file to be written See OpenAPI.Renderer.Module.filename/2 for the default implementation.","ref":"OpenAPI.Renderer.html#c:location/2","title":"OpenAPI.Renderer.location/2","type":"callback"},{"doc":"Create the contents of a file in quoted Abstract Syntax Tree (AST) form This callback is the primary function called to render a file. The default implementation calls several other callbacks, each of which my be overridden separately: OpenAPI.Renderer.render_moduledoc/2 OpenAPI.Renderer.render_using/2 OpenAPI.Renderer.render_default_client/2 OpenAPI.Renderer.render_schema/2 OpenAPI.Renderer.render_operations/2 See OpenAPI.Renderer.Module.render/2 for the default implementation.","ref":"OpenAPI.Renderer.html#c:render/2","title":"OpenAPI.Renderer.render/2","type":"callback"},{"doc":"Render the @default_client module attribute in an operation module When using the default operation function renderer, every operation function includes a line: client = opts [ :client ] || @default_client This allows callers to override the client implementation without having to pass the default module in as an argument. This callback renders the definition of the @default_client module attribute, effectively choosing which module will be called for every operation. See OpenAPI.Renderer.Module.render_default_client/2 for the default implementation.","ref":"OpenAPI.Renderer.html#c:render_default_client/2","title":"OpenAPI.Renderer.render_default_client/2","type":"callback"},{"doc":"Render the @moduledoc portion of the file Users of a client library may lean on this documentation to find the operation or schema they need. While the default implementation presents a fairly basic line of documentation depending on whether the file contains operations or a schema, custom implementations of this callback could provide rich and helpful instructions to consumers. See OpenAPI.Renderer.Module.render_moduledoc/2 for the default implementation.","ref":"OpenAPI.Renderer.html#c:render_moduledoc/2","title":"OpenAPI.Renderer.render_moduledoc/2","type":"callback"},{"doc":"Render the associated types, docstring, typespec, and function for a single operation The default implementation of this function calls several other callbacks (all named render_operation_* ) which can be overridden individually. See OpenAPI.Renderer.Operation.render/2 for the default implementation.","ref":"OpenAPI.Renderer.html#c:render_operation/2","title":"OpenAPI.Renderer.render_operation/2","type":"callback"},{"doc":"Render the @doc portion of an operation function See OpenAPI.Renderer.Operation.render_doc/2 for the default implementation.","ref":"OpenAPI.Renderer.html#c:render_operation_doc/2","title":"OpenAPI.Renderer.render_operation_doc/2","type":"callback"},{"doc":"Render the main function portion of an operation See OpenAPI.Renderer.Operation.render_function/2 for the default implementation.","ref":"OpenAPI.Renderer.html#c:render_operation_function/2","title":"OpenAPI.Renderer.render_operation_function/2","type":"callback"},{"doc":"Render the @spec portion of an operation function See OpenAPI.Renderer.Operation.render_spec/2 for the default implementation.","ref":"OpenAPI.Renderer.html#c:render_operation_spec/2","title":"OpenAPI.Renderer.render_operation_spec/2","type":"callback"},{"doc":"Render the associated types, docstring, typespec, and function for all operations This is the primary function called to render all operations in a file. The default implementation calls several other callbacks (all named render_operation* ) which can be overridden individually. See OpenAPI.Renderer.Operation.render_all/2 for the default implementation.","ref":"OpenAPI.Renderer.html#c:render_operations/2","title":"OpenAPI.Renderer.render_operations/2","type":"callback"},{"doc":"Render the types, struct, and field function for schemas not related to an operation This is the primary function called to render schemas. The default implementation calls several other callbacks (all named render_schema_* ) which can be overridden individually. See OpenAPI.Renderer.Schema.render/2 for the default implementation.","ref":"OpenAPI.Renderer.html#c:render_schema/2","title":"OpenAPI.Renderer.render_schema/2","type":"callback"},{"doc":"Render a function __fields__/1 that return a keyword list of schema fields and their types See OpenAPI.Renderer.Schema.render_field_function/2 for the default implementation.","ref":"OpenAPI.Renderer.html#c:render_schema_field_function/2","title":"OpenAPI.Renderer.render_schema_field_function/2","type":"callback"},{"doc":"Render the defstruct call for the schema types contained in the file See OpenAPI.Renderer.Schema.render_struct/2 for the default implementation.","ref":"OpenAPI.Renderer.html#c:render_schema_struct/2","title":"OpenAPI.Renderer.render_schema_struct/2","type":"callback"},{"doc":"Render the typespecs for schema types contained in the file See OpenAPI.Renderer.Schema.render_types/2 for the default implementation.","ref":"OpenAPI.Renderer.html#c:render_schema_types/2","title":"OpenAPI.Renderer.render_schema_types/2","type":"callback"},{"doc":"Render one or more use statements to include in the file Another route for customization of the outputted code is via meta-programming. This callback enables library authors to use any module they like at the top of files that contain schemas, operations, or both. The referenced modules can then perform additional compile-time changes. See OpenAPI.Renderer.Module.render_using/2 for the default implementation.","ref":"OpenAPI.Renderer.html#c:render_using/2","title":"OpenAPI.Renderer.render_using/2","type":"callback"},{"doc":"","ref":"OpenAPI.Renderer.html#run/1","title":"OpenAPI.Renderer.run/1","type":"function"},{"doc":"Write a rendered file to the filesystem This callback can expect to receive a OpenAPI.Renderer.File.t/0 struct with formatted file contents expressed as iodata in the contents field. It should write the file to the filesystem at the appropriate location included in the location field. While the return value is irrelevant, a simple :ok will suffice. See OpenAPI.Renderer.Util.write/2 for the default implementation.","ref":"OpenAPI.Renderer.html#c:write/2","title":"OpenAPI.Renderer.write/2","type":"callback"},{"doc":"Collection of operations and schemas that belong to the same file As rendering occurs for a particular file, this struct will collect all of the necessary data to continue the process. It has the following fields: ast : Once rendered, the Abstract Syntax Tree (AST), or quoted form, of the file contents. This AST may include additional formatting-related metadata. contents : Once formatted, the iodata form of the file contents. This is what will be used by the default implementation of the write callback. location : Once determined, the filesystem location (path) where the file is intended to be written. module : Name of the Elixir module contained in the file. operations : List of OpenAPI.Processor.Operation.t/0 contained in the file. schemas : List of OpenAPI.Processor.Schema.t/0 contained in the file. All of this state is managed by the code generator, so it is unlikely that callbacks would need to write to this struct directly.","ref":"OpenAPI.Renderer.File.html","title":"OpenAPI.Renderer.File","type":"module"},{"doc":"File contents See module documentation for additional information.","ref":"OpenAPI.Renderer.File.html#t:t/0","title":"OpenAPI.Renderer.File.t/0","type":"type"},{"doc":"Default implementation for callbacks related to rendering operation and schema modules This module contains the default implementations for: OpenAPI.Renderer.location/2 OpenAPI.Renderer.render/2 OpenAPI.Renderer.render_default_client/2 OpenAPI.Renderer.render_moduledoc/2 OpenAPI.Renderer.render_using/2 These focus on portions of modules that may appear in both schema and operation modules. Configuration All configuration offered by the functions in this module lives under the output key of the active configuration profile. For example (default values shown): # config/config.exs config :oapi_generator , default : [ output : [ base_module : nil , default_client : Client , location : &quot;&quot; , operation_subdirectory : &quot;&quot; , operation_use : nil , schema_subdirectory : &quot;&quot; , schema_use : nil ] ]","ref":"OpenAPI.Renderer.Module.html","title":"OpenAPI.Renderer.Module","type":"module"},{"doc":"Choose the filesystem location for the given file based on its module name and contents Default implementation of OpenAPI.Renderer.location/2 . If the file does not contain any operations, the file name is chosen as the concatenation of: The base location set in the output configuration, The schema_subdirectory set in the output configuration, and The underscored module name (ex. Some.Schema becomes some/schema.ex ) Configuration Use output.location to set the directory of all outputted files (ex. lib ). Then, optionally split operations and schemas into separate directories using output.operation_subdirectory and output.schema_subdirectory . This can be useful to show which modules are generated vs. those that are written by hand. config :oapi_generator , default : [ output : [ location : &quot;lib&quot; , operation_subdirectory : &quot;operations&quot; , schema_subdirectory : &quot;schemas&quot; ] ] With this configuration, an schema module named My.ExampleSchema would be output to lib/schemas/my/example_schema.ex .","ref":"OpenAPI.Renderer.Module.html#filename/2","title":"OpenAPI.Renderer.Module.filename/2","type":"function"},{"doc":"Create the contents of a file in quoted Abstract Syntax Tree (AST) form Default implementation of OpenAPI.Renderer.render/2 . This callback is the primary function called to render a file. It makes use of several other callbacks of the renderer (in this order), each of which my be overridden separately: OpenAPI.Renderer.render_moduledoc/2 OpenAPI.Renderer.render_using/2 OpenAPI.Renderer.render_default_client/2 OpenAPI.Renderer.render_schema/2 OpenAPI.Renderer.render_operations/2 Besides concatenating the results of these functions, this function also writes the defmodule call itself. Configuration Use output.base_module to determine a prefix to the name of all modules created by the generator. For example, given the following configuration: config :oapi_generator , default : [ output : [ base_module : MyClientLibrary ] ] A file with module name MySchema would be output as MyClientLibrary.MySchema . Usually, this configuration contains the name of your library's root module.","ref":"OpenAPI.Renderer.Module.html#render/2","title":"OpenAPI.Renderer.Module.render/2","type":"function"},{"doc":"Construct the @default_client module attribute for modules with operations Default implementation of OpenAPI.Renderer.render_default_client/2 . This allows callers to override the client implementation without having to pass the default module in as an argument. This callback renders the definition of the @default_client module attribute, effectively choosing which module will be called for every operation. Configuration Use output.default_client to choose which module is set. A value of false or nil will cause the module attribute not to be set at all, which may cause compilation errors if using the default implementation of the operation function renderer. config :oapi_generator , default : [ output : [ default_client : MyLib.MyClient ] ] This will result in a statement @default_client MyLib.MyClient to be added to any module that contains operations. Note that the output.base_module configuration is not used in this case. If the configuration is unset, then a default module of [base module].Client will be used, based on the output.base_module configuration.","ref":"OpenAPI.Renderer.Module.html#render_default_client/2","title":"OpenAPI.Renderer.Module.render_default_client/2","type":"function"},{"doc":"Construct the @moduledoc portion of the file based on the file contents Default implementation of OpenAPI.Renderer.render_moduledoc/2 . This function provides a basic moduledoc for each file. If the file contains only schemas, then the moduledoc focuses on the structs and types it provides: Provides struct and types for a MySchema If the file contains operations, it focuses on those: Provides API endpoints related to MyOperations","ref":"OpenAPI.Renderer.Module.html#render_moduledoc/2","title":"OpenAPI.Renderer.Module.render_moduledoc/2","type":"function"},{"doc":"Construct any use statements that should be included in the file Default implementation of OpenAPI.Renderer.render_using/2 . Another route for customization of the outputted code is via meta-programming. This callback enables library authors to use any module they like at the top of files that contain schemas, operations, or both. The referenced modules can then perform additional compile-time changes. Configuration Use output.operation_use to include a use statement at the top of each file that contains any operations, and output.schema_use to similarly include a use statement at the top of files containing a schema. Keep in mind that some files may contain both operations and a schema. config :oapi_generator , default : [ output : [ schema_use : MyLib.Schema ] ] This will result in a statement use MyLib.Schema (note that the output.base_module configuration is not used in this context).","ref":"OpenAPI.Renderer.Module.html#render_using/2","title":"OpenAPI.Renderer.Module.render_using/2","type":"function"},{"doc":"Default implementation for callbacks related to rendering operations This module contains the default implementations for: OpenAPI.Renderer.render_operations/2 OpenAPI.Renderer.render_operation/2 OpenAPI.Renderer.render_operation_doc/2 OpenAPI.Renderer.render_operation_function/2 OpenAPI.Renderer.render_operation_spec/2 These focus on the operation functions and surrounding code. Configuration All configuration offered by the functions in this module lives under the output key of the active configuration profile. For example (default values shown): # config/config.exs config :oapi_generator , default : [ output : [ base_module : nil , types : [ error : nil ] ] ]","ref":"OpenAPI.Renderer.Operation.html","title":"OpenAPI.Renderer.Operation","type":"module"},{"doc":"Render a single operation Default implementation of OpenAPI.Renderer.render_operation/2 . This implementation calls the following callbacks and concatenates their results: OpenAPI.Renderer.render_operation_doc/2 OpenAPI.Renderer.render_operation_spec/2 OpenAPI.Renderer.render_operation_function/2","ref":"OpenAPI.Renderer.Operation.html#render/2","title":"OpenAPI.Renderer.Operation.render/2","type":"function"},{"doc":"Render all of the operations contained in a single module Default implementation of OpenAPI.Renderer.render_operations/2 . This implementation simply iterates through the operations contained in a file, sorted by their function name, and calls the OpenAPI.Renderer.render_operation/2 callback for each. The results are returned as a list of nodes.","ref":"OpenAPI.Renderer.Operation.html#render_all/2","title":"OpenAPI.Renderer.Operation.render_all/2","type":"function"},{"doc":"Render the docstring for an operation function Default implementation of OpenAPI.Renderer.render_operation_doc/2 . This implementation uses the docstring created by the processor without modification.","ref":"OpenAPI.Renderer.Operation.html#render_doc/2","title":"OpenAPI.Renderer.Operation.render_doc/2","type":"function"},{"doc":"Render the function definition for an operation function Default implementation of OpenAPI.Renderer.render_operation_function/2 . This implementation constructs a function that calls a dynamically chosen client module's request function with details about the operation. Example def my_operation ( path_param , body , opts \\ [ ] ) do client = opts [ :client ] || @default_client query = Keyword . take ( opts , [ :query_param ] ) client . request ( %{ args : [ path_param : path_param , body : body ] , call : { Example.Operations , :my_operation } , url : &quot;/path/to/ \#{ path_param } &quot; , body : body , method : :post , query : query , request : [ { &quot;application/json&quot; , :map } ] , response : [ { 200 , :map } , { 404 , { Example.NotFoundError , :t } } ] , opts : opts } ) end","ref":"OpenAPI.Renderer.Operation.html#render_function/2","title":"OpenAPI.Renderer.Operation.render_function/2","type":"function"},{"doc":"Render the spec of an operation function Default implementation of OpenAPI.Renderer.render_operation_spec/2 .","ref":"OpenAPI.Renderer.Operation.html#render_spec/2","title":"OpenAPI.Renderer.Operation.render_spec/2","type":"function"},{"doc":"Default implementation for callbacks related to rendering schemas This module contains the default implementations for: OpenAPI.Renderer.render_schema/2 OpenAPI.Renderer.render_schema_field_function/2 OpenAPI.Renderer.render_schema_struct/2 OpenAPI.Renderer.render_schema_types/2 Extra Fields It is sometimes useful for client libraries to store additional information on the structs defined by the API description. This kind of private information is supported using the output.extra_fields configuration. Each entry in the keyword list must use the name of the field as the atom key and the type as the value. Types can be any valid OpenAPI.Processor.Type.t/0 . Example: config :oapi_generator , default : [ output : [ __info__ : :map ] ] This will result in a field info: map added to every schema typespec and :info added to every struct definition. Configuration All configuration offered by the functions in this module lives under the output key of the active configuration profile. For example (default values shown): # config/config.exs config :oapi_generator , default : [ output : [ extra_fields : [ ] ] ]","ref":"OpenAPI.Renderer.Schema.html","title":"OpenAPI.Renderer.Schema","type":"module"},{"doc":"Render a schema, including typespecs, struct definition, and field function Default implementation of OpenAPI.Renderer.render_schema/2 . This implementation operates on schemas that appear in multiple contexts. If a schema appears in exactly one context as the request or response body of a function, it will instead be rendered by an operation callback. This function calls the following other callbacks and concatenates their results: OpenAPI.Renderer.render_schema_types/2 OpenAPI.Renderer.render_schema_struct/2 OpenAPI.Renderer.render_schema_field_function/2","ref":"OpenAPI.Renderer.Schema.html#render/2","title":"OpenAPI.Renderer.Schema.render/2","type":"function"},{"doc":"Render a function __fields__/1 that returns information about schema field types Default implementation of OpenAPI.Renderer.render_schema_field_function/2 . This implementation renders a function spec and header with one clause for each schema type.","ref":"OpenAPI.Renderer.Schema.html#render_field_function/2","title":"OpenAPI.Renderer.Schema.render_field_function/2","type":"function"},{"doc":"Render a single struct definition for all of the given schemas Default implementation of OpenAPI.Renderer.render_schema_struct/2 . This implementation combines the fields of all schemas to create one struct. It also uses the output.extra_fields configuration to add additional fields to the struct for private use by the client library. See Extra Fields in this module's documentation.","ref":"OpenAPI.Renderer.Schema.html#render_struct/2","title":"OpenAPI.Renderer.Schema.render_struct/2","type":"function"},{"doc":"Render the typespec(s) for all of the given schemas Default implementation of OpenAPI.Renderer.render_schema_types/2 . This implementation uses the output.extra_fields configuration to add additional fields to the struct for private use by the client library. See Extra Fields in this module's documentation.","ref":"OpenAPI.Renderer.Schema.html#render_types/2","title":"OpenAPI.Renderer.Schema.render_types/2","type":"function"},{"doc":"State of the render phase of code generation This struct is created at the beginning of the render phase using data from the overall generator OpenAPI.State . It has the following fields: files : Map of module names and their associated OpenAPI.Renderer.File.t/0 structs. This map is built using the operations and schemas data. implementation : Module configured as the implementation of the renderer (defaults to OpenAPI.Renderer ). Callbacks must use this field when calling other render callbacks. operations : List of OpenAPI.Processor.Operation.t/0 structs processed in the previous phase. These operations may appear in any order due to map key ordering. profile : Name of the active configuration profile. Callbacks must use this field when looking up configuration from the application environment. schemas : Map of schema references to their OpenAPI.Processor.Schema.t/0 structs processed in the previous phase. The reference-keyed map is included to make it easier for callbacks to look up a schema by its reference, as this is often how operations will refer to them. All of this state is managed by the code generator, and it is unlikely that a callback would need to transform this struct directly.","ref":"OpenAPI.Renderer.State.html","title":"OpenAPI.Renderer.State","type":"module"},{"doc":"Render phase state See module documentation for additional information.","ref":"OpenAPI.Renderer.State.html#t:t/0","title":"OpenAPI.Renderer.State.t/0","type":"type"},{"doc":"Default implementation and helpers related to formatting and writing files This module contains the default implementations for: OpenAPI.Renderer.format/2 OpenAPI.Renderer.write/2 It also contains several helpers for working with ASTs, including the addition of formatting metadata necessary to create consistent code.","ref":"OpenAPI.Renderer.Util.html","title":"OpenAPI.Renderer.Util","type":"module"},{"doc":"Flatten and remove nil elements from a list of AST nodes This helper deals with cases in which certain sections of code are rendered conditionally, or with variable lengths of statements. nil values will be removed, and nested lists of nodes will be flattened. Example header = if condition , do : quote ( do : IO . puts ( &quot;List&quot; ) ) statements = for item &lt;- items , do : quote ( do : IO . puts ( &quot; * \#{ item } &quot; ) ) clean_list ( [ header , statements ] )","ref":"OpenAPI.Renderer.Util.html#clean_list/1","title":"OpenAPI.Renderer.Util.clean_list/1","type":"function"},{"doc":"Convert an AST into formatted code as a string Default implementation of OpenAPI.Renderer.format/2 . The AST may include optional formatting metadata (ex. delimiter , indentation , or end_of_expression ). It will be formatted to a line width of 98 to match the default Mix formatter. In addition, any @moduledoc or @doc statements that contain a newline character will be modified to use &quot;&quot;&quot; as the delimiter.","ref":"OpenAPI.Renderer.Util.html#format/2","title":"OpenAPI.Renderer.Util.format/2","type":"function"},{"doc":"Walks the given AST and replaces @doc and @moduledoc strings with &quot;&quot;&quot; blocks if the contents have newlines","ref":"OpenAPI.Renderer.Util.html#format_multiline_docs/1","title":"OpenAPI.Renderer.Util.format_multiline_docs/1","type":"function"},{"doc":"Enforce the existence of whitespace after an expression This helper is useful for cases in which single-line expressions should be separated from the following line by whitespace, but the formatter would not naturally insert that whitespace. For example: @my_attribute &quot;Hello&quot; @spec my_function :: String . t ( ) def my_function , do : @my_attribute It may be desirable to insert whitespace following the module attribute @my_attribute . By calling this function on that node, the following will be output: @my_attribute &quot;Hello&quot; @spec my_function :: String . t ( ) def my_function , do : @my_attribute If a list of nodes is given, the last node will receive the additional whitespace metadata.","ref":"OpenAPI.Renderer.Util.html#put_newlines/1","title":"OpenAPI.Renderer.Util.put_newlines/1","type":"function"},{"doc":"Collapse nested unions and replace references with {module, type} identifiers This function renders most types exactly as they are expressed internally (ex. {:string, :generic} ), however it transforms certain union types to be more human-readable and it replaces schema references with the equivalent {Module, :type} .","ref":"OpenAPI.Renderer.Util.html#to_readable_type/2","title":"OpenAPI.Renderer.Util.to_readable_type/2","type":"function"},{"doc":"Render an internal type as a typespec To the best of its ability, this function constructs an accurate typespec for the internal type given. Note that this is somewhat lossy; for example, many distinct types of strings will map to the String.t() type.","ref":"OpenAPI.Renderer.Util.html#to_type/2","title":"OpenAPI.Renderer.Util.to_type/2","type":"function"},{"doc":"Replace enum types with the equivalent list of const types This low-level helper is used by to_type/2 when simplifying union types.","ref":"OpenAPI.Renderer.Util.html#unwrap_enums/1","title":"OpenAPI.Renderer.Util.unwrap_enums/1","type":"function"},{"doc":"Flatten nested union types This low-level helper is used by to_readable_type/2 and to_type/2 when simplifying union types.","ref":"OpenAPI.Renderer.Util.html#unwrap_unions/1","title":"OpenAPI.Renderer.Util.unwrap_unions/1","type":"function"},{"doc":"Write a rendered file to the filesystem Default implementation of OpenAPI.Renderer.write/2 . This implementation writes the file contents to the location and ensures an additional newline is included at the end of the file. It also ensures that any subdirectories are created prior to writing. Any failure will result in a raised error.","ref":"OpenAPI.Renderer.Util.html#write/2","title":"OpenAPI.Renderer.Util.write/2","type":"function"},{"doc":"OpenAPI description as read by the read phase Modules contained in this namespace represent portions of the OpenAPI spec. While there is some occasional processing done by the reader (for example, to add additional context to a schema while it is read), most of this data is an exact replica of what is contained in the API description. All spec modules have a function decode/2 which is not intended to be called by client library authors, but does the work of parsing the JSON or Yaml contents.","ref":"OpenAPI.Spec.html","title":"OpenAPI.Spec","type":"module"},{"doc":"Open API specification","ref":"OpenAPI.Spec.html#t:t/0","title":"OpenAPI.Spec.t/0","type":"type"},{"doc":"Raw components map from the OpenAPI spec","ref":"OpenAPI.Spec.Components.html","title":"OpenAPI.Spec.Components","type":"module"},{"doc":"","ref":"OpenAPI.Spec.Components.html#t:t/0","title":"OpenAPI.Spec.Components.t/0","type":"type"},{"doc":"Raw external documentation definition from the OpenAPI spec","ref":"OpenAPI.Spec.ExternalDocumentation.html","title":"OpenAPI.Spec.ExternalDocumentation","type":"module"},{"doc":"","ref":"OpenAPI.Spec.ExternalDocumentation.html#t:t/0","title":"OpenAPI.Spec.ExternalDocumentation.t/0","type":"type"},{"doc":"Raw information map from the OpenAPI spec","ref":"OpenAPI.Spec.Info.html","title":"OpenAPI.Spec.Info","type":"module"},{"doc":"","ref":"OpenAPI.Spec.Info.html#t:t/0","title":"OpenAPI.Spec.Info.t/0","type":"type"},{"doc":"Raw contact information from the OpenAPI spec","ref":"OpenAPI.Spec.Info.Contact.html","title":"OpenAPI.Spec.Info.Contact","type":"module"},{"doc":"","ref":"OpenAPI.Spec.Info.Contact.html#t:t/0","title":"OpenAPI.Spec.Info.Contact.t/0","type":"type"},{"doc":"Raw license information from the OpenAPI spec","ref":"OpenAPI.Spec.Info.License.html","title":"OpenAPI.Spec.Info.License","type":"module"},{"doc":"","ref":"OpenAPI.Spec.Info.License.html#t:t/0","title":"OpenAPI.Spec.Info.License.t/0","type":"type"},{"doc":"Raw link from the OpenAPI spec","ref":"OpenAPI.Spec.Link.html","title":"OpenAPI.Spec.Link","type":"module"},{"doc":"","ref":"OpenAPI.Spec.Link.html#t:t/0","title":"OpenAPI.Spec.Link.t/0","type":"type"},{"doc":"Raw path header from the OpenAPI spec","ref":"OpenAPI.Spec.Path.Header.html","title":"OpenAPI.Spec.Path.Header","type":"module"},{"doc":"","ref":"OpenAPI.Spec.Path.Header.html#t:t/0","title":"OpenAPI.Spec.Path.Header.t/0","type":"type"},{"doc":"Raw operation path from the OpenAPI spec","ref":"OpenAPI.Spec.Path.Item.html","title":"OpenAPI.Spec.Path.Item","type":"module"},{"doc":"","ref":"OpenAPI.Spec.Path.Item.html#decode_delete/2","title":"OpenAPI.Spec.Path.Item.decode_delete/2","type":"function"},{"doc":"","ref":"OpenAPI.Spec.Path.Item.html#decode_get/2","title":"OpenAPI.Spec.Path.Item.decode_get/2","type":"function"},{"doc":"","ref":"OpenAPI.Spec.Path.Item.html#decode_head/2","title":"OpenAPI.Spec.Path.Item.decode_head/2","type":"function"},{"doc":"","ref":"OpenAPI.Spec.Path.Item.html#decode_options/2","title":"OpenAPI.Spec.Path.Item.decode_options/2","type":"function"},{"doc":"","ref":"OpenAPI.Spec.Path.Item.html#decode_parameters/2","title":"OpenAPI.Spec.Path.Item.decode_parameters/2","type":"function"},{"doc":"","ref":"OpenAPI.Spec.Path.Item.html#decode_patch/2","title":"OpenAPI.Spec.Path.Item.decode_patch/2","type":"function"},{"doc":"","ref":"OpenAPI.Spec.Path.Item.html#decode_post/2","title":"OpenAPI.Spec.Path.Item.decode_post/2","type":"function"},{"doc":"","ref":"OpenAPI.Spec.Path.Item.html#decode_put/2","title":"OpenAPI.Spec.Path.Item.decode_put/2","type":"function"},{"doc":"","ref":"OpenAPI.Spec.Path.Item.html#decode_trace/2","title":"OpenAPI.Spec.Path.Item.decode_trace/2","type":"function"},{"doc":"","ref":"OpenAPI.Spec.Path.Item.html#t:t/0","title":"OpenAPI.Spec.Path.Item.t/0","type":"type"},{"doc":"Raw operation from the OpenAPI spec","ref":"OpenAPI.Spec.Path.Operation.html","title":"OpenAPI.Spec.Path.Operation","type":"module"},{"doc":"","ref":"OpenAPI.Spec.Path.Operation.html#decode_parameters/2","title":"OpenAPI.Spec.Path.Operation.decode_parameters/2","type":"function"},{"doc":"","ref":"OpenAPI.Spec.Path.Operation.html#decode_request_body/2","title":"OpenAPI.Spec.Path.Operation.decode_request_body/2","type":"function"},{"doc":"","ref":"OpenAPI.Spec.Path.Operation.html#t:t/0","title":"OpenAPI.Spec.Path.Operation.t/0","type":"type"},{"doc":"Raw path parameter from the OpenAPI spec","ref":"OpenAPI.Spec.Path.Parameter.html","title":"OpenAPI.Spec.Path.Parameter","type":"module"},{"doc":"","ref":"OpenAPI.Spec.Path.Parameter.html#decode_content/2","title":"OpenAPI.Spec.Path.Parameter.decode_content/2","type":"function"},{"doc":"","ref":"OpenAPI.Spec.Path.Parameter.html#decode_examples/2","title":"OpenAPI.Spec.Path.Parameter.decode_examples/2","type":"function"},{"doc":"","ref":"OpenAPI.Spec.Path.Parameter.html#decode_schema/2","title":"OpenAPI.Spec.Path.Parameter.decode_schema/2","type":"function"},{"doc":"","ref":"OpenAPI.Spec.Path.Parameter.html#t:t/0","title":"OpenAPI.Spec.Path.Parameter.t/0","type":"type"},{"doc":"Raw request body from the OpenAPI spec","ref":"OpenAPI.Spec.RequestBody.html","title":"OpenAPI.Spec.RequestBody","type":"module"},{"doc":"","ref":"OpenAPI.Spec.RequestBody.html#t:t/0","title":"OpenAPI.Spec.RequestBody.t/0","type":"type"},{"doc":"Raw response from the OpenAPI spec","ref":"OpenAPI.Spec.Response.html","title":"OpenAPI.Spec.Response","type":"module"},{"doc":"","ref":"OpenAPI.Spec.Response.html#t:t/0","title":"OpenAPI.Spec.Response.t/0","type":"type"},{"doc":"Raw JSON schema specification from the OpenAPI spec","ref":"OpenAPI.Spec.Schema.html","title":"OpenAPI.Spec.Schema","type":"module"},{"doc":"JSON Schema specification In addition to the data derived from the JSON or Yaml specification, this struct also contains some contextual information including its absolute and referenced location in the spec. All such fields are prefixed with $oag_ .","ref":"OpenAPI.Spec.Schema.html#t:t/0","title":"OpenAPI.Spec.Schema.t/0","type":"type"},{"doc":"Raw schema discriminator from the OpenAPI spec","ref":"OpenAPI.Spec.Schema.Discriminator.html","title":"OpenAPI.Spec.Schema.Discriminator","type":"module"},{"doc":"","ref":"OpenAPI.Spec.Schema.Discriminator.html#t:t/0","title":"OpenAPI.Spec.Schema.Discriminator.t/0","type":"type"},{"doc":"Raw schema encoding from the OpenAPI spec","ref":"OpenAPI.Spec.Schema.Encoding.html","title":"OpenAPI.Spec.Schema.Encoding","type":"module"},{"doc":"","ref":"OpenAPI.Spec.Schema.Encoding.html#t:t/0","title":"OpenAPI.Spec.Schema.Encoding.t/0","type":"type"},{"doc":"Raw schema example from the OpenAPI spec","ref":"OpenAPI.Spec.Schema.Example.html","title":"OpenAPI.Spec.Schema.Example","type":"module"},{"doc":"","ref":"OpenAPI.Spec.Schema.Example.html#t:t/0","title":"OpenAPI.Spec.Schema.Example.t/0","type":"type"},{"doc":"Raw media schema from the OpenAPI spec","ref":"OpenAPI.Spec.Schema.Media.html","title":"OpenAPI.Spec.Schema.Media","type":"module"},{"doc":"","ref":"OpenAPI.Spec.Schema.Media.html#t:t/0","title":"OpenAPI.Spec.Schema.Media.t/0","type":"type"},{"doc":"Raw XML definition from the OpenAPI spec","ref":"OpenAPI.Spec.Schema.XML.html","title":"OpenAPI.Spec.Schema.XML","type":"module"},{"doc":"","ref":"OpenAPI.Spec.Schema.XML.html#t:t/0","title":"OpenAPI.Spec.Schema.XML.t/0","type":"type"},{"doc":"Raw server from the OpenAPI spec","ref":"OpenAPI.Spec.Server.html","title":"OpenAPI.Spec.Server","type":"module"},{"doc":"","ref":"OpenAPI.Spec.Server.html#t:t/0","title":"OpenAPI.Spec.Server.t/0","type":"type"},{"doc":"Raw server variable from the OpenAPI spec","ref":"OpenAPI.Spec.Server.Variable.html","title":"OpenAPI.Spec.Server.Variable","type":"module"},{"doc":"","ref":"OpenAPI.Spec.Server.Variable.html#t:t/0","title":"OpenAPI.Spec.Server.Variable.t/0","type":"type"},{"doc":"Raw tag from the OpenAPI spec","ref":"OpenAPI.Spec.Tag.html","title":"OpenAPI.Spec.Tag","type":"module"},{"doc":"","ref":"OpenAPI.Spec.Tag.html#t:t/0","title":"OpenAPI.Spec.Tag.t/0","type":"type"},{"doc":"A highly-configurable code generator that combines ergonomics with maintainability. OpenAPI is a standard way to describe REST APIs on the web. Anyone can create an OpenAPI description document that includes the available endpoints, expected request data, and possible responses. For example, GitHub maintains a comprehensive OpenAPI description for their services. Generating code from an OpenAPI description can be relatively easy — this project certainly isn't the first — but there's a catch: API descriptions often don't translate into ergonomic code. Most users of an API client library don't want to think about the difference between a NullableRepository and Repository , as in the OpenAPI 3.0 GitHub API description. (They have the same fields, but one has nullable: true .) Users just want to get back a %Repository{} or nil . The goal of this library is to create ergonomic client libraries from OpenAPI descriptions. At the same time, the changes made to the code are easily repeatable (fully automated) for the sake of maintainability. Think: the friendliness of your favorite hand-crafted client library applied to the scale of large APIs. See an example client library here . For more on how this is accomplished, see Configuration below and the configuration guide .","ref":"readme.html","title":"Overview","type":"extras"},{"doc":"This library is available on Hex.pm. Add the dependency in mix.exs : def deps do [ { :oapi_generator , &quot;0.1.0-rc.0&quot; } ] end Then install the dependency using mix deps.get .","ref":"readme.html#installation","title":"Overview - Installation","type":"extras"},{"doc":"The real power of this library is in the available configuration. Although the options are conceptually simple, they add up to a better user experience. This project uses configuration profiles to allow multiple configurations with the same package. To get started, create a profile called default in your configuration: config :oapi_generator , default : [ output : [ base_location : &quot;lib/example&quot; , base_module : Example ] ] This is the minimum viable configuration for most client libraries. It will create modules namespaced with Example. and save files in lib/example . Some the options supported by the generator out-of-the-box include: Ignoring schemas and operations Renaming schemas Grouping schemas into module namespaces Merging schemas to create a struct with multiple typespecs Writing schemas and operation modules to different locations Introducing additional schema fields Adding custom use statements to generated modules Overriding function return types For more information, see the configuration guide .","ref":"readme.html#configuration","title":"Overview - Configuration","type":"extras"},{"doc":"If the available configuration isn't enough, client library authors can also reimplement portions of the code generator using plugins . Most of the crucial parts of the processing and rendering of code are implemented as default callbacks for a behaviour. These can be overridden for additional flexibility. See the plugins guide for additional information.","ref":"readme.html#plugins","title":"Overview - Plugins","type":"extras"},{"doc":"Once the library is installed and configured, use mix api.gen with the name of the configuration profile and the OpenAPI description file(s): mix api.gen default path/to/rest-api-description/spec.yaml","ref":"readme.html#usage","title":"Overview - Usage","type":"extras"},{"doc":"Code of Conduct Contribution Guidelines License OpenAPI Specification","ref":"readme.html#further-reading","title":"Overview - Further Reading","type":"extras"},{"doc":"If you like this library or it makes you money, please consider sponsoring .","ref":"readme.html#sponsorship","title":"Overview - Sponsorship","type":"extras"},{"doc":"","ref":"code_of_conduct.html","title":"Code of Conduct","type":"extras"},{"doc":"We as members, contributors, and leaders pledge to make participation in our community a harassment-free experience for everyone, regardless of age, body size, visible or invisible disability, ethnicity, sex characteristics, gender identity and expression, level of experience, education, socio-economic status, nationality, personal appearance, race, caste, color, religion, or sexual identity and orientation. We pledge to act and interact in ways that contribute to an open, welcoming, diverse, inclusive, and healthy community.","ref":"code_of_conduct.html#our-pledge","title":"Code of Conduct - Our Pledge","type":"extras"},{"doc":"Examples of behavior that contributes to a positive environment for our community include: Demonstrating empathy and kindness toward other people Being respectful of differing opinions, viewpoints, and experiences Giving and gracefully accepting constructive feedback Accepting responsibility and apologizing to those affected by our mistakes, and learning from the experience Focusing on what is best not just for us as individuals, but for the overall community Examples of unacceptable behavior include: The use of sexualized language or imagery, and sexual attention or advances of any kind Trolling, insulting or derogatory comments, and personal or political attacks Public or private harassment Publishing others' private information, such as a physical or email address, without their explicit permission Other conduct which could reasonably be considered inappropriate in a professional setting","ref":"code_of_conduct.html#our-standards","title":"Code of Conduct - Our Standards","type":"extras"},{"doc":"Community leaders are responsible for clarifying and enforcing our standards of acceptable behavior and will take appropriate and fair corrective action in response to any behavior that they deem inappropriate, threatening, offensive, or harmful. Community leaders have the right and responsibility to remove, edit, or reject comments, commits, code, wiki edits, issues, and other contributions that are not aligned to this Code of Conduct, and will communicate reasons for moderation decisions when appropriate.","ref":"code_of_conduct.html#enforcement-responsibilities","title":"Code of Conduct - Enforcement Responsibilities","type":"extras"},{"doc":"This Code of Conduct applies within all community spaces, and also applies when an individual is officially representing the community in public spaces. Examples of representing our community include using an official e-mail address, posting via an official social media account, or acting as an appointed representative at an online or offline event.","ref":"code_of_conduct.html#scope","title":"Code of Conduct - Scope","type":"extras"},{"doc":"Instances of abusive, harassing, or otherwise unacceptable behavior may be reported to the community leaders responsible for enforcement by email . All complaints will be reviewed and investigated promptly and fairly. All community leaders are obligated to respect the privacy and security of the reporter of any incident.","ref":"code_of_conduct.html#enforcement","title":"Code of Conduct - Enforcement","type":"extras"},{"doc":"Community leaders will follow these Community Impact Guidelines in determining the consequences for any action they deem in violation of this Code of Conduct: 1. Correction Community Impact : Use of inappropriate language or other behavior deemed unprofessional or unwelcome in the community. Consequence : A private, written warning from community leaders, providing clarity around the nature of the violation and an explanation of why the behavior was inappropriate. A public apology may be requested. 2. Warning Community Impact : A violation through a single incident or series of actions. Consequence : A warning with consequences for continued behavior. No interaction with the people involved, including unsolicited interaction with those enforcing the Code of Conduct, for a specified period of time. This includes avoiding interactions in community spaces as well as external channels like social media. Violating these terms may lead to a temporary or permanent ban. 3. Temporary Ban Community Impact : A serious violation of community standards, including sustained inappropriate behavior. Consequence : A temporary ban from any sort of interaction or public communication with the community for a specified period of time. No public or private interaction with the people involved, including unsolicited interaction with those enforcing the Code of Conduct, is allowed during this period. Violating these terms may lead to a permanent ban. 4. Permanent Ban Community Impact : Demonstrating a pattern of violation of community standards, including sustained inappropriate behavior, harassment of an individual, or aggression toward or disparagement of classes of individuals. Consequence : A permanent ban from any sort of public interaction within the community.","ref":"code_of_conduct.html#enforcement-guidelines","title":"Code of Conduct - Enforcement Guidelines","type":"extras"},{"doc":"This Code of Conduct is adapted from the Contributor Covenant , version 2.1, available at https://www.contributor-covenant.org/version/2/1/code_of_conduct.html . Community Impact Guidelines were inspired by Mozilla's code of conduct enforcement ladder . For answers to common questions about this code of conduct, see the FAQ at https://www.contributor-covenant.org/faq . Translations are available at https://www.contributor-covenant.org/translations .","ref":"code_of_conduct.html#attribution","title":"Code of Conduct - Attribution","type":"extras"},{"doc":"Hello there. Thank you for your interest in contributing to this project. With a wide variety of OpenAPI descriptions in the world, this project could use your assistance. Reading and following the guidelines in this document is an act of kindness and respect for other contributors. With your help, we can address issues, make changes, and work together efficiently.","ref":"contributing.html","title":"Contributing","type":"extras"},{"doc":"There are many ways to contribute to this project: Individuals with experience in Elixir can help us to address observed and potential issues. Users of REST APIs with OpenAPI descriptions can try the generator and report any issues or recommendations for improvement they encounter. Users of the package can help to test new use-cases and patterns. Documentation improves everyone's experience. Anyone can assist in the triage of bugs, identifying root causes, and proposing solutions. Please keep in mind the intended scope of this package: to provide a code generator that balances an ergonomic user experience with maintainability. Assume that the OpenAPI description that serves as input to this library will change often, and manually changing the output is impractical.","ref":"contributing.html#ways-to-contribute","title":"Contributing - Ways to Contribute","type":"extras"},{"doc":"All contributions to this project must align with the code of conduct . Beyond that, we ask: Please be kind. Maintaining this project is not paid work. Please create an issue before embarking on major refactors or new features. Let's make reasonable effort to support as many OpenAPI descriptions as possible.","ref":"contributing.html#ground-rules","title":"Contributing - Ground Rules","type":"extras"},{"doc":"If you find a security-related issue with this project, please refrain from opening a public issue and instead email the maintainer .","ref":"contributing.html#security-issues","title":"Contributing - Security Issues","type":"extras"},{"doc":"For maintainers, the process of releasing this package to Hex.pm centers around git tags. To make a new release: Update the Changelog with a new header that has today's date and the new version. Include any missing notes from changes since the last release, and any additional upgrade instructions users may need. Update the @version number in mix.exs . The form should be X.Y.Z , with optional suffixes, but no leading v . Update the Installation instructions in README.md to have the newest non-suffixed version number. Commit the above changes with a generic commit message, such as Release X.Y.Z . Tag the commit as X.Y.Z , with optional suffixes, but no leading v . Push the commits and tag (for example, git push origin main --tags ). Observe the GitHub Action titled Release . This action automatically publishes the package to Hex.pm.","ref":"contributing.html#releases","title":"Contributing - Releases","type":"extras"},{"doc":"MIT License Copyright (c) 2022 AJ Foster Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"License","type":"extras"},{"doc":"This project exists for its configuration capabilities. Most API client libraries are either feature complete (due to code generation) or ergonomic (due to hand-crafting code), but not both. With the right configuration — and a little bit of luck with the OpenAPI description — your client library can be both. The following sections outline the configuration available for the default implementations of the various callbacks used by this library. See the Plugins documentation for information about overriding the default behaviours with custom implementations.","ref":"configuration.html","title":"Configuration","type":"extras"},{"doc":"This library uses configuration profiles to allow for multiple sets of configuration at once. In practice, this means that all configuration lives under a top-level key that will be referenced when running the generator. For example: # config/config.exs config :oapi_generator , my_profile : [ output : [ base_module : MyClientLibrary ] ] To use this configuration, run mix api.gen my_profile path/to/description.json or call OpenAPI.run(&quot;my_profile&quot;, [&quot;path/to/description/json&quot;]) . Not sure what to name the profile? Start with default .","ref":"configuration.html#profiles","title":"Configuration - Profiles","type":"extras"},{"doc":"Operations are the actions you can take in an API: the HTTP requests that are possible. This code generator takes an operation-first mindset when generating code. For example, schemas that are defined in a description but not referenced in any API operation will not be output. Following is an example operation module that has been annotated with the configuration options involved in various parts of the rendered output. Example Module # Existence: `ignore` # Location: `output.location`, `output.operation_subdirectory` # Module name: `output.base_module`, `naming.default_operation_module` defmodule Example.Operations do @moduledoc &quot;&quot;&quot; Provides API endpoints related to repos &quot;&quot;&quot; # `output.operation_use`, `output_schema_use` (if schemas are present) use Example.Helper # `output.default_client` @default_client Example.Client # Schemas would appear here, if present. @doc &quot;&quot;&quot; Summary of the operation &quot;&quot;&quot; # `output.base_module`, `output.types.error` @spec my_operation ( String . t ( ) , map , keyword ) :: :ok | { :error , Example.Error . t ( ) } def my_operation ( path_param , body , opts \\\\ [ ] ) do client = opts [ :client ] || @default_client query = Keyword . take ( opts , [ :query_param ] ) client . request ( %{ args : [ path_param : path_param , body : body ] , call : { Example.Operations , :my_operation } , url : &quot;/path/to/ \#{ path_param } &quot; , body : body , method : :post , query : query , request : [ { &quot;application/json&quot; , :map } ] , response : [ { 200 , :map } , { 404 , { Example.NotFoundError , :t } } ] , opts : opts } ) end end Below are some of the highlights from the available configuration. See the Option Reference section for an exhaustive list of the available options. Processor: Naming At the moment, configuration related to the naming and placement of operation functions is limited. If you have ideas related to this, please share them in GitHub Discussions. If an operation does not have any tags, and its operation ID does not contain any / characters, it will be placed in a default module named [BaseModule].Operations . This module name can be controlled using the naming.default_operation_module configuration: config :oapi_generator , default : [ naming : [ base_module : MyClientLibrary , default_operation_module : MyOperations ] ] Learn more in the documentation for OpenAPI.Processor.Naming.operation_modules/2 . Processor: Ignore The ignore option allows operations to be ignored based on their Operation IDs or paths in the API description. Patterns can be exact strings or regular expressions. Learn more in the documentation for OpenAPI.Processor.Ignore . Renderer: Default Client output.default_client defines the module that will be called in each operation function. By allowing the client module to be defined at the time of code generation (with this option) and at runtime (with the client option passed to any operation call), this code generator maximizes flexibility. For example, tests can supply a special test client module when they call client operations. This need not be the end of the flexibility, however. The GitHub client library defines a &quot;stack&quot; system within its client module, allowing users to easily swap libraries for handling HTTP requests and decoding JSON. Renderer: Meta-programming output.operation_use defines a module that should be included as a use [output.operation_use] statement at the top of every module that contains operations. This can be useful for meta-programming, such as using compilation hooks to performed advanced modifications of the generated code. Renderer: Types output.types , and specifically its error key, allows library authors to override the return type of operation functions. It's fairly common for client libraries to create their own error that acts as a superset for all of the errors defined in the OpenAPI description. This provides a consistent interface for client library consumers.","ref":"configuration.html#operations","title":"Configuration - Operations","type":"extras"},{"doc":"Much of the configuration of this code generator relates to the naming and output of schemas. Remember that the library takes an operation-first mindset, and will not output schemas that are not actively used by an operation. Following is an example operation module that has been annotated with the configuration options involved in various parts of the rendered output. Example Schema # Existence: `ignore` # Location: `output.location`, `output.schema_subdirectory` # Module name: `output.base_module` defmodule Example.MySchema do @moduledoc &quot;&quot;&quot; Provides struct and types for a MySchema &quot;&quot;&quot; # `output_schema_use` use Example.Helper @type t :: % __MODULE__ { example : String . t ( ) } defstruct [ # output.extra_fields :__extra__ , :example ] @doc false @spec __fields__ ( atom ) :: keyword def __fields__ ( type \\\\ :t ) def __fields__ ( :t ) do [ example : { :string , :generic } ] end end Below are some of the highlights from the available configuration. See the Option Reference section for an exhaustive list of the available options. Processor: Naming Schemas can be renamed, grouped, and merged. Applying variations of these options to the API description can turn generated code from confusing to ergonomic rather quickly. Learn more in the documentation for OpenAPI.Processor.Naming.schema_module_and_type/2 . Processor: Ignore The ignore option allows operations to be ignored based on their Operation IDs or paths in the API description. Patterns can be exact strings or regular expressions. Learn more in the documentation for OpenAPI.Processor.Ignore . Renderer: Extra Fields output.extra_fields allows authors to insert additional fields into every outputted schema. For example, the GitHub library adds an __info__ map to each schema. Like the __meta__ field provided by Ecto.Schema or the private field on Plug.Conn , this field can hold additional library-specific information without interfering with the API's own data. Renderer: Meta-programming output.schema_use allows authors to insert a use [output.schema_use] statement at the top of every module containing a schema. A corresponding module must be supplied by the library with a __using__/1 macro. Inside this macro, library authors can inject additional code that may be helpful. For example: defmodule MyLibrary.Schema do defmacro __using__ ( _opts ) do quote do @derive { Jason.Encoder , except : [ :__info__ ] } end end end Inside the macro, you can reference the name of the current module using __MODULE__ , along with any other variables that are part of the macro environment.","ref":"configuration.html#schemas","title":"Configuration - Schemas","type":"extras"},{"doc":"Below are all of the configuration options offered by the default implementations of the processor and renderer. They are expressed in terms of nested keyword lists. For example, output.base_module represents the following: config :oapi_generator , default : [ output [ base_module : ... ] ] Remember that all configuration values must be contained within a profile. ignore : List of patterns (string or regular expression) representing operations or schemas to ignore during code generation. Defaults to an empty list of patterns. See OpenAPI.Processor.Ignore for more information. naming.default_operation_module : Module into which operation functions will be rendered if a module cannot be determined based on their operation ID or tags. The configuration should not include the base module configured in output.base_module . Defaults to Operations . See OpenAPI.Processor.Naming.operation_modules/2 for more information. naming.group : List of module namespaces to use while naming operations and schemas. Defaults to an empty list of modules. See OpenAPI.Processor.Naming.group_schema/2 for more information. naming.merge : List of tuples containing patterns and replacements to use when merging schema modules. Defaults to an empty list of merges. See OpenAPI.Processor.Naming.merge_schema/2 for more information. naming.operation_use_tags : Whether to use tags when determining module names for operations. Defaults to true . See OpenAPI.Processor.Naming.operation_modules/2 for more information. naming.rename : List of tuples containing patterns and replacements to use when renaming modules. Defaults to an empty list of replacements. See OpenAPI.Processor.Naming.rename_schema/2 for more information. output.base_module : Base module of the generated code. This is often the name of the library you intend to create, and it acts as a prefix for all rendered modules. Defaults to nil , or no module prefix. See OpenAPI.Renderer.Module.render/2 for more information. output.default_client : Default client to use in operation modules. Every operation function calls a dynamic module to perform requests, and this configuration determines the default value. Defaults to [output.base_module].Client . See OpenAPI.Renderer.Module.render_default_client/2 for more information. output.extra_fields : Additional fields to add to all schema struct definitions and their typespecs, expressed as a keyword list of types. This can be useful for private data the library wishes to add to all outputted data. Defaults to an empty list of fields. See OpenAPI.Renderer.Schema for more information. output.location : Base filesystem location for all rendered files. This is often a directory like lib to follow Elixir conventions. Defaults to the current working directory. See OpenAPI.Renderer.Module.filename/2 for more information. output.operation_subdirectory : Subdirectory to use for all rendered files containing operations. This is an optional way to colocate generated operation modules in a single directory away from other parts of the client library. Defaults to the same location as output.location . See OpenAPI.Renderer.Module.filename/2 for more information. output.operation_use : Module to include as a use statement at the top of every module containing operations. Defaults to no used module. See OpenAPI.Renderer.Module.render_using/2 for more information. output.schema_subdirectory : Subdirectory to use for all rendered files containing only schemas. This is an optional way to colocate generated schema modules in a single directory away from other parts of the client library. Defaults to the same location as output.location . See OpenAPI.Renderer.Module.filename/2 for more information. output.schema_use : Module to include as a use statement at the top of every module containing only schemas. Defaults to no used module. See OpenAPI.Renderer.Module.render_using/2 for more information. output.types.error : Type to override the error return type of all operation functions. This is useful when the client intends to normalize errors from the API. By default, the error type is a union of all possible error responses for the operation. See OpenAPI.Renderer.Operation.render_spec/2 for more information. reader.additional_files : List of paths to supplemental root files of an API description. Defaults to an empty list. See OpenAPI.Reader for more information. reader.file : Path to the root file of an API description. This option is often supplied to the mix api.gen mix task instead. See OpenAPI.Reader for more information.","ref":"configuration.html#option-reference","title":"Configuration - Option Reference","type":"extras"},{"doc":"Sometimes, the configuration available using the default implementation of this library isn't enough. For advanced use-cases, library authors have the option to override the default implementations and create their own workflows. This guide provides more details and a brief example of such an integration. First, however, it is important to understand how the library is divided up:","ref":"plugins.html","title":"Plugins","type":"extras"},{"doc":"There are three overall phases involved in code generation: Read the API description, dereference it, and create a large in-memory data structure representing the specification. This phase begins with one or more filenames (JSON or YAML) to read and ends with an Elixir representation of each document. Process the description, converting the data into structures that are more useful for code generation. This phase begins with the dereferenced API description and ends with a modified set of structs that represent the files to be written. Render the code using an AST-based renderer. This phase begins with the final state of the API description and ends with formatted Elixir code written to the filesystem. Through all three phases, the library uses an OpenAPI.State struct to keep track of changes. Each phase also implements its own &quot;state&quot; struct, with intermediate data useful for that phase.","ref":"plugins.html#phases","title":"Plugins - Phases","type":"extras"},{"doc":"Both the process and render phases define a behaviour with optional callbacks. By default, the following modules are used for each phase: config :oapi_generator , my_profile : [ processor : OpenAPI.Processor , renderer : OpenAPI.Renderer ] Client library authors may configure their own module in place of the default implementation. For example, a custom renderer may start like this: # config/config.exs config :oapi_generator , my_profile : [ renderer : MyLibrary.Renderer ] # lib/my_library/renderer.ex defmodule MyLibrary.Renderer do use OpenAPI.Renderer end With use OpenAPI.Renderer (or similarly with use OpenAPI.Processor ), default implementations of all behaviour callbacks are provided automatically. This allows authors to override only those callbacks they are interested in. # lib/my_library/renderer.ex defmodule MyLibrary.Renderer do use OpenAPI.Renderer # Override the default write/2 callback # with an alternative implementation. def write ( state , file ) do # ... end end The full list of callbacks can be found in the Callbacks section below and in the documentation for OpenAPI.Processor and OpenAPI.Renderer .","ref":"plugins.html#behaviours","title":"Plugins - Behaviours","type":"extras"},{"doc":"Since custom plugins are implemented in each client applications, authors can choose to configure them in whatever manner suits the client application best. It is recommended that the method of configuration maximize the repeatability of the code generation for easier contributions. Default implementations of each callback generally use the application environment for configuration. Because of this, if library authors use the same configuration profiles setup as the default implementations, it is recommended that each custom plugin choose a unique configuration key within the profile that does not conflict with other callbacks.","ref":"plugins.html#configuration","title":"Plugins - Configuration","type":"extras"},{"doc":"Below is a list of all available callbacks in order of their use, along with their default implementations: Processor : OpenAPI.Processor For each operation OpenAPI.Processor.ignore_operation?/2 : OpenAPI.Processor.Ignore.ignore_operation?/2 OpenAPI.Processor.operation_docstring/3 : OpenAPI.Processor.Operation.docstring/3 OpenAPI.Processor.operation_request_method/2 : OpenAPI.Processor.Operation.request_method/2 OpenAPI.Processor.operation_module_names/2 : OpenAPI.Processor.Naming.operation_modules/2 For each operation module name OpenAPI.Processor.operation_function_name/2 : OpenAPI.Processor.Naming.operation_function/2 OpenAPI.Processor.operation_request_body/2 : OpenAPI.Processor.Operation.request_body/2 OpenAPI.Processor.operation_response_body/2 : OpenAPI.Processor.Operation.response_body/2 For each schema OpenAPI.Processor.ignore_schema?/2 : OpenAPI.Processor.Ignore.ignore_schema?/2 OpenAPI.Processor.schema_module_and_type/2 : OpenAPI.Processor.Naming.schema_module_and_type/2 Renderer : OpenAPI.Renderer For each file (identified by module name) OpenAPI.Renderer.render/2 : OpenAPI.Renderer.Module.render/2 OpenAPI.Renderer.render_moduledoc/2 : OpenAPI.Renderer.Module.render_moduledoc/2 OpenAPI.Renderer.render_using/2 : OpenAPI.Renderer.Module.render_using/2 OpenAPI.Renderer.render_default_client/2 : OpenAPI.Renderer.Module.render_default_client/2 OpenAPI.Renderer.render_schema/2 : OpenAPI.Renderer.Schema.render/2 OpenAPI.Renderer.render_schema_types/2 : OpenAPI.Renderer.Schema.render_types/2 OpenAPI.Renderer.render_schema_struct/2 : OpenAPI.Renderer.Schema.render_struct/2 OpenAPI.Renderer.render_schema_field_function/2 : OpenAPI.Renderer.Schema.render_field_function/2 OpenAPI.Renderer.render_operations/2 : OpenAPI.Renderer.Operation.render_all/2 For each operation in the file OpenAPI.Renderer.render_operation/2 : OpenAPI.Renderer.Operation.render/2 OpenAPI.Renderer.render_operation_doc/2 : OpenAPI.Renderer.Operation.render_doc/2 OpenAPI.Renderer.render_operation_spec/2 : OpenAPI.Renderer.Operation.render_spec/2 OpenAPI.Renderer.render_operation_function/2 : OpenAPI.Renderer.Operation.render_function/2 OpenAPI.Renderer.format/2 : OpenAPI.Renderer.Util.format/2 OpenAPI.Renderer.location/2 : OpenAPI.Renderer.Module.filename/2 OpenAPI.Renderer.write/2 : OpenAPI.Renderer.Util.write/2 Each callback represents an opportunity for client library authors to inject their own logic into the code generator. If popular overrides are discovered, they may be added to the default implementation as well.","ref":"plugins.html#callbacks","title":"Plugins - Callbacks","type":"extras"},{"doc":"Unlike most packages on Hex.pm, the target audience for this project is other library authors , and not necessarily end-users. While it is certainly possible for application developers to generate code directly in their Elixir apps, it's likely that most OpenAPI specifications will be consumed by a generic client library (like oapi_github ) instead. As the author of a library with code generated from an OpenAPI description, it's important to establish a healthy relationship between your library and the spec. For example, if your library is based on a specification that is updated often, you likely want to set a reasonable cadence (ex. monthly) for updating the generated code. Otherwise, maintenance can become a burden very quickly. Following are some recommendations for how to establish this relationship.","ref":"client-author-guide.html","title":"Client Author Guide","type":"extras"},{"doc":"As mentioned above, some OpenAPI descriptions are updated often. Before introducing API versioning, GitHub continuously updated its OpenAPI spec with both new endpoints and corrections for existing ones. A library author could potentially release new versions every week in an attempt to keep up. However, it's unlikely that real-time updates of the generated code is necessary. Here are a few options for releasing updates to the generated code: If the description updates often with new endpoints that consumers of your library are eager to use, a rapid or as-needed release cadence may be appropriate. This might mean creating a scheduled CI job that regularly re-generates the code based on the latest copy of the specification and opens a pull request with the changes. Or, it might mean encouraging users of the library to open an issue or pull request when they encounter an unsupported endpoint. If the description updates often with fixes to the specification, then a periodic release cadence may be appropriate. This would help users of the library avoid issues while also reducing the maintenance burden. If the description has well-versioned or occasional updates, the client may wish to &quot;follow&quot; the release cadence of the specification. In this case, the version of the description may play a central role in the client, and should likely be included as an .api-version file in the release. This makes it clear to users of the library what API version they can expect.","ref":"client-author-guide.html#cadence","title":"Client Author Guide - Cadence","type":"extras"},{"doc":"Some libraries will be best served by an as-needed update cadence. In this case, simple guidelines around the contribution of generated code can make a big difference. Here is an excerpt from the contribution guidelines for the GitHub client library that uses this generator: Updating the Generated Code If you intend to open a PR with updates to the generated code based on the latest GitHub OpenAPI description, please read carefully: Please use the latest commit from the official repository at the time of your contribution. Please use descriptions-next/api.github.com/api.github.com.yaml — not descriptions or a GitHub Enterprise release. Use mix api.gen default path/to/descriptions-next/api.github.com/api.github.com.yaml to regenerate the code. Please also change the .api-version file if appropriate. Please include the commit SHA of the official repository in the description of your pull request. Please do not make any other changes in the same PR (for example, changing this library's version). If you run into any unexpected issues while generating the code, please open an issue. Thank you for your help! Although not all contributors will read this guidance, steps like this can make it much easier for you as a library author to simply merge the pull request and release a new version.","ref":"client-author-guide.html#contributions","title":"Client Author Guide - Contributions","type":"extras"},{"doc":"Despite best efforts, OpenAPI descriptions often don't cover all of the API endpoints available. For example, although GitHub provides a nearly-comprehensive specification of hundreds of endpoints, there are ID-based endpoints like /repositories/{id} that are not publicly documented. A library author may know this a priori and wish to include these endpoints in the generated code. For this case, it is recommended that the author maintain a separate, supplemental OpenAPI description document with just enough information to generate the additional code. This (presumably small) supplemental description can be committed along with the client code while the official description remains separate.","ref":"client-author-guide.html#supplemental-specs","title":"Client Author Guide - Supplemental Specs","type":"extras"}]